program example_addcolumn

  use dal
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  logical(kind=bool), dimension(:), pointer :: b
  integer(kind=int8), dimension(:), pointer :: i8
  integer(kind=int16), dimension(:), pointer :: i16
  integer(kind=int32), dimension(:), pointer :: i32
  real(kind=single), dimension(:), pointer :: r32
  real(kind=double), dimension(:), pointer :: r64
  character(len=1024) :: s
  integer i

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"some table",100)

  col = addColumn(tab,"bool",BOOLEAN)
  b => boolData(col)
  do i=0,numberOfRows(tab)-1
    b(i) = ( modulo (i,2) .eq. 0 )
  end do

  col = addColumn(tab,"int8",INTEGER8,units="cm",comment="int8 column")
  i8 => int8Data(col)
  write(*,*) shape(i8)
  do i=0,numberOfRows(tab)-1
    i8(i) = i
  end do

  col = addColumn(tab,"int16",INTEGER16,units="dm",comment="int16 column")
  i16 => int16Data(col)
  do i=0,numberOfRows(tab)-1
    i16(i) = 2*i
  end do

  col = addColumn(tab,"int32",INTEGER32,units="m",comment="in32 column")
  i32 => int32Data(col)
  do i=0,numberOfRows(tab)-1
    i32(i) = 3*i
  end do

  col = addColumn(tab,"real32",REAL32,units="Dm",comment="real32 column")
  r32 => real32Data(col)
  do i=0,numberOfRows(tab)-1
    r32(i) = 0.5*i
  end do

  col = addColumn(tab,"real64",REAL64,units="hm",comment="real64 column")
  r64 => real64Data(col)
  do i=0,numberOfRows(tab)-1
    r64(i) = 0.25*i
  end do

  col = addColumn(tab,"string",STRING,comment="string column",dimensions=(/80/))
  do i=0,numberOfRows(tab)-1
    write(s,*) "string",i
    call setStringCell(col,i,s)
  end do

  call release(set)

end program example_addcolumn
