#include <dal.h>
#include <stdio.h>
#include <math.h>

ColumnData *xData, *yData, *rData;

void proc(SubTable* st)
{
  unsigned int i;
  /* One could use subTableData(st,"x") */
  int16*  x = int16Data(xData);
  int16*  y = int16Data(yData);
  real64* r = real64Data(rData);
  for (i = 0; i < subTableCount(st); ++i) {
    printf("%hd %hd\n", x[i], y[i]);
    r[i] = sqrt( sqr(x[i]) * sqr(y[i]) );
  }
}

int main()
{
  DataSet *set;
  Table* tab;
  SubTable* st;

  set = dataSet("test.dat",MODIFY);
  tab = table(set,"events",MODIFY);
  st = subTable(tab);
  xData = subTableAddColumn(st,"x",READ);
  yData = subTableAddColumn(st,"y",READ);
  rData = subTableAddColumn(st,"r",CREATE);
  forEachSubTable(st,proc);
  dataSetRelease(set);
  return 0;
}

