using namespace std;
#include <Dal.h>
#include <iostream>
#include <cmath>

class Report : public TableProcessor {

  void table(Table*) {
    xData = addColumn("x",Column::Read);
    yData = addColumn("y",Column::Read);
    rData = addColumn("r",Column::Create);
  }

  void proc(SubTable& st) {
    // One could use st.data("x") instead of xData
    int16  *x = xData->int16Data();
    int16  *y = yData->int16Data();
    real64 *r = rData->real64Data();

    for (unsigned i = 0; i < st.count(); ++i) {
      clog << x[i] << ' ' << y[i] << endl;
      r[i] = sqrt( sqr(x[i]) + sqr(y[i]) );
    }
  }

  ColumnData *xData, *yData, *rData;
};

int main()
{
  DataSet *set = dataSetServer->open("test.dat",
	DataSet::Modify);
  Table* table = set->table("events",Table::Modify);
  Report report;
  report.process(table);
  delete set;
  return 0;
}
