#include <string>

typedef short int16;
typedef double real64;

template<class T> sqr(const T& a) { return a*a; }

class DataSet;
class Table;
class Column;
class ColumnData;

class Dal {

  public:

    enum AccessMode { Read, Modify, Create };
};

class DataServer : public Dal {

  public:

    DataSet* open(const std::string&, AccessMode);
};

class DataSet : public Dal {

  public:

    Table* table(const std::string&, AccessMode);
};

class Table : public Dal {

  public:

    Column* column(const std::string&, AccessMode);

    unsigned long count() const;

    bool next();

    void seek(unsigned long from, unsigned long count);
};

class Column : public Dal {

  public:

    ColumnData* data();
};

class ColumnData {

  public:

    int16* int16Data();
    real64* real64Data();
};

class TableProcessor {

  public:

    void process(Table*);
};

extern DataServer *dataSetServer;
