module dal

  use daltypes

  integer, parameter :: READ = 10
  integer, parameter :: CREATE = 11
  integer, parameter :: MODIFY = 12

contains

  function int16Data(col)
    type(ColumnT), intent(in) :: col
    integer(kind=int16), dimension(:), pointer :: int16Data
  end function

  function real64Data(col)
    type(ColumnT), intent(in) :: col
    real(kind=double), dimension(:), pointer :: real64Data
  end function

  function dataSet(name,mode)
    character(len=*), intent(in) :: name
    integer, intent(in) :: mode
    type(DataSetT) dataSet
  end function

  function table(set,name,mode)
    type(DataSetT), intent(in) :: set
    character(len=*), intent(in) :: name
    integer, intent(in) :: mode
    type(TableT) table
  end function

  function column(tab,name,mode)
    type(TableT), intent(in) :: tab
    character(len=*), intent(in) :: name
    integer, intent(in) :: mode
    type(ColumnT) column
  end function

  function next(tab)
    type(TableT), intent(in) :: tab
    logical next
  end function

end module dal
