/*************************************************************** 
* 
* DalArray.h & XMM Science Analysis System (SAS) 
* 
* Class representing DAL Array. 
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalArray.h,v 1.2 2004/03/05 14:43:00 eojero Exp $
* 
*****************************************************************/ 
#ifndef DAL_ARRAY_H
#define DAL_ARRAY_H


#include <Dal.h>


#include "DalDataComponent.h"
#include "DalBlock.h"
#include "DalDataSet.h"


class DalArray : public virtual Array, public DalBlock, public DalDataComponent
{
	public :
		DalArray(
			const std::string &			name,
			DataType			dataType,
			const longVec&			size,
			const std::string &			units,
			const std::string &			label,
			DalDataSet *			parent );

		virtual ~DalArray() {}
		virtual DalArray& operator=( const Array& ) = 0;

		ArrayData * data(
				const longVec &		from=zero,
				const longVec &		to=zero,
				AccessMode		accessMode=AsParent) const;

	private :

		virtual ArrayData * makeArrayData(
				AccessMode		accessMode ) const = 0;


};


#endif


