using namespace std;
/*************************************************************** 
* 
* DalDal.cc          & XMM Science Analysis System (SAS) 
* 
* Class representing Dal
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalDal.cc,v 1.2 2004/03/05 14:43:01 eojero Exp $
* 
*****************************************************************/ 


#include <errstr.h>
#include <Tracer.h>
#include "DalDal.h"


DalDal::DalDal( AccessMode accessMode, const DalDal * parentAccessMode )
    :	_accessMode( accessMode ),
	_alwaysAllowModify( parentAccessMode ? parentAccessMode -> _alwaysAllowModify : false ),
		_parentAccessMode( parentAccessMode )
{
    PROC
	ENDPROC
}


Dal::AccessMode
DalDal::mode() const
{
	PROC
	RETURN _accessMode == AsParent ? _parentAccessMode -> mode() : _accessMode;
}


void
DalDal::mode( AccessMode newAccessMode )
{
    PROC
	_accessMode = newAccessMode;
    ENDPROC
}


void
DalDal::alwaysAllowModify( bool onoff )
{
	PROC
	_alwaysAllowModify = onoff;
	ENDPROC
}


void
DalDal::checkIfReadOnly() const
{
	PROC
	    if(
		mode() == Dal::Read
		&&
		!_alwaysAllowModify )
	    {
		errstr << "An attempt was made to modify a read-only object." << Sas::error( "readOnly" );
	    } // if
	ENDPROC
}
