/*************************************************************** 
* 
* DalSeekable.h & XMM Science Analysis System (SAS) 
* 
* Class representing a Seekable object.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalSeekable.h,v 1.2 2004/03/05 14:43:01 eojero Exp $ 
* 
*****************************************************************/ 
#ifndef DAL_SEEKABLE_H
#define DAL_SEEKABLE_H


#include "Dal.h"
#include "Tracer.h"


template<class T>
class DalSeekable : public virtual Seekable<T>
{
	public :

		DalSeekable( T from, T count ) : _from( from ), _count( count ) { PROC ENDPROC }
		virtual ~DalSeekable(){}
		T from() const { PROC RETURN _from; }
		T count() const { PROC RETURN _count; }
		virtual void seek( T from, T count )  { PROC _from = from; _count = count; ENDPROC }

	private :
		T	_from;
		T	_count;
};



#endif


