/*************************************************************** 
* 
* MemCellData.h            & XMM Science Analysis System (SAS) 
* 
* Class representing the Data in a Column Cell. 
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemCellData.h,v 1.2 2004/03/05 14:43:03 eojero Exp $ 
* 
*****************************************************************/ 
#ifndef MEM_CELL_DATA
#define MEM_CELL_DATA


#include <Dal.h>
#include "MemData.h"
#include "DataStorage.h"
#include "DalCellData.h"
#include "DalColumn.h"


class MemCellData : public DalCellData, public MemData<DalColumn>
{
	public :

		MemCellData(
			DataStorage *			data,
			const DalColumn *		parent,
			unsigned long			rowNumber,
			unsigned long			from,
			unsigned long			count,
			AccessMode			accessMode );

		virtual ~MemCellData();

		void size( unsigned long elements );
		unsigned long size() const;
		unsigned long row() const;
		unsigned long elements() const;
		void seek( unsigned long from, unsigned long count );

};


#endif


