using namespace std;
#include<cassert>
#include <Dal.h>


const char* longStr1 = "1234567890123456789012345678901234567890123456789012345678901234567890";


const char* longStr2 = "09876543210987654321098765432109876543210987654321098765432109876543210987654321098765432109876543210987654321098765432109876543210987654321";

static void
fill()
{
  DataSet* set = dataSetServer->open("test.dat",DataSet::Create);
  *set->addAttribute("sbool","set bool comment") = false;
  *set->addAttribute("sint","set int comment","int unit") = 1;
  *set->addAttribute("sreal","set real comment","real unit") = 2.5;
  *set->addAttribute("sstring","set string comment") = "a set string";
  //*set->addAttribute("vstring","set long string comment") = longStr2;
  //*set->addAttribute("lstring","set long string comment") = longStr1;

  vector<unsigned long> size;
  size.push_back(1);
  size.push_back(2);
  size.push_back(3);
  Array* arr = set->addArray("PRIMARY", Array::Int32, size);
  *arr->addAttribute("abool","arr bool comment") = true;
  *arr->addAttribute("aint","arr int comment","int unit") = 4;
  *arr->addAttribute("areal","arr real comment","real unit") = 3.5;
  *arr->addAttribute("astring","arr string comment") = "an array string";
  *arr->addAttribute("vstring","set long string comment") = longStr2;
  *arr->addAttribute("lstring","arr long string comment") = longStr1;

  arr = set->addArray("array", Array::Int32, size);
  *arr->addAttribute("abool","arr bool comment") = true;
  *arr->addAttribute("aint","arr int comment","int unit") = 4;
  *arr->addAttribute("areal","arr real comment","real unit") = 3.5;
  *arr->addAttribute("astring","arr string comment") = "an array string";
  *arr->addAttribute("lstring","arr long string comment") = longStr1;
  *arr->addAttribute("lstring","arr long string comment") = longStr2;

  Table* tab = set->addTable("table",10);
  *tab->addAttribute("abool","tab bool comment") = false;
  *tab->addAttribute("aint","tab int comment","int unit") = 7;
  *tab->addAttribute("areal","tab real comment","real unit") = 5.5;
  *tab->addAttribute("astring","tab string comment") = "a table string";
  *tab->addAttribute("lstring","tab long string comment") = longStr1;
  *tab->addAttribute("lstring","tab long string comment") = longStr2;

  // **********************
  // Set column attributes.
  // **********************
  Column* col1 = tab-> addColumn("col1", Column::Int32 );
  *col1->addAttribute("tlmin","minimum","int unit") = 1;
  *col1->addAttribute("tlmax","maximum","int unit") = 2;

  Column* col2 = tab-> addColumn("col2", Column::Int32 );
  *col2->addAttribute("tlmin","minimum","int unit") = 11;
  *col2->addAttribute("tlmax","maximum","int unit") = 22;

  Column* col3 = tab-> addColumn("col3", Column::Int32 );
  *col3 -> addAttribute( col2 -> attribute( "tlmin" )) = 111;
  *col3 -> addAttribute( col2 -> attribute( "tlmax" )) = 111;

  dataSetServer->close(set);

}


static void
check()
{
  DataSet* set;
  set = dataSetServer->open("test.dat",DataSet::Read);
  Attribute* att;

  att = set -> attribute( "sbool" );
  assert( att -> dataType() == Attribute::Bool );
  assert( att -> asBool() == false );
  assert( att -> label() == "set bool comment" );

  att = set -> attribute( "sint" );
  assert( att -> dataType() == Attribute::Int );
  assert( att -> asInt() == 1 );
  assert( att -> label() == "set int comment" );
  assert( att -> units() == "int unit" );

  att = set -> attribute( "sreal" );
  assert( att -> dataType() == Attribute::Real );
  assert( att -> asReal() == 2.5 );
  assert( att -> label() == "set real comment" );
  assert( att -> units() == "real unit" );

  att = set -> attribute( "sstring" );
  assert( att -> dataType() == Attribute::DString );
  assert( att -> asString() == "a set string" );
  assert( att -> label() == "set string comment" );

  //att = set -> attribute( "vstring" );
  //assert( att -> dataType() == Attribute::DString );
  //assert( att -> asString() == longStr2 );
  //assert( att -> label() == "set long string comment" );

  //att = set -> attribute( "lstring" );
  //assert( att -> dataType() == Attribute::DString );
  //assert( att -> asString() == longStr1 );
  //assert( att -> label() == "set long string comment" );

  //*set->addAttribute("sstring","set string comment") = "a set string";
  //*set->addAttribute("vstring","set long string comment") = longStr2;
  //*set->addAttribute("lstring","set long string comment") = longStr1;
  //for( unsigned int i = 0; i < 10; ++i )
  //{
   // set = dataSetServer->open("test.dat",DataSet::Modify);
  dataSetServer->close(set);
  //} // for
}


int
main()
{
  fill();
  check();

  return 0;
}
