using namespace std;
#include <cstdio>
#include<cassert>


#include <Dal.h>
#include <sstream>
#include "StopWatch.h"
#include <iostream>
/* AI gcc4 porting
 * system was not declared in this scope => include cstdlib
 */
#include <string.h>

void
test()
{
  unsigned long nRows = 1000;

  DataSet* set = dataSetServer->open("test.dat",DataSet::Create);
  Table* tab = set->addTable("some table",nRows);
  Column *col;
  ColumnData *d;

  col = tab->addColumn("bool",Column::Bool,"bool data");
  d = col->data();
  bool8 *b = d->boolData();
  for (unsigned long i = 0; i < nRows; ++i)
    b[i] = (i%2 ? true : false);
  delete d;

  col = tab->addColumn("int8",Column::Int8,"int8 data","mm");
  d = col->data();
  int8 *i8 = d->int8Data();
  for (unsigned long i = 0; i < nRows; ++i)
    i8[i] = i % 100;
  delete d;

  col = tab->addColumn("uint16",Column::Uint16,"uint16 data","cm");
  d = col->data();
  uint16 *ui16 = d->uint16Data();
  for (unsigned long i = 0; i < nRows; ++i)
    ui16[i] = 2*i;
  delete d;

  col = tab->addColumn("int16",Column::Int16,"int16 data","cm");
  d = col->data();
  int16 *i16 = d->int16Data();
  for (unsigned long i = 0; i < nRows; ++i)
    i16[i] = 2*i;
  delete d;

  col = tab->addColumn("uint32",Column::Uint32,"uint32 data","dm");
  d = col->data();
  uint32 *ui32 = d->uint32Data();
  for (unsigned long i = 0; i < nRows; ++i)
    ui32[i] = 3*i;
  delete d;

  col = tab->addColumn("int32",Column::Int32,"int32 data","dm");
  d = col->data();
  int32 *i32 = d->int32Data();
  for (unsigned long i = 0; i < nRows; ++i)
    i32[i] = 3*i;
  delete d;

  col = tab->addColumn("real32",Column::Real32,"real32 data","m");
  d = col->data();
  real32 *r32 = d->real32Data();
  for (unsigned long i = 0; i < nRows; ++i)
    r32[i] = 0.5*i;
  delete d;

  col = tab->addColumn("real64",Column::Real64,"real64 data","Dm");
  d = col->data();
  real64 *r64 = d->real64Data();
  for (unsigned long i = 0; i < nRows; ++i)
    r64[i] = 0.25*i;
  delete d;

  vector<unsigned long> strlen;
  strlen.push_back(10);
  col = tab->addColumn("string",Column::DString,"string data","",strlen);
  d = col->data();
  char *s = d->stringData();
  int len = d->size()[0];
  assert( len == 10 );
  for (unsigned long i = 0; i < nRows; ++i) {
    char	ss[ len + 1 ];
    sprintf( ss, "string%ld", i );
    //stringstream ss;
    //ss << "string"<<i;
    strncpy(s + d->position(i), ss, len);
  }
  delete d;

  dataSetServer->close(set);

}

int main()
{
	// *********************************
	// Get clock for timing information.
	// *********************************
	StopWatch		cpuWatch( StopWatch::CPU );
	StopWatch		calenderWatch( StopWatch::Calender );


	for( unsigned int i = 0; i < 10; ++i )
	{
		test();
		cout << "[" << i << "] CPU time: " << cpuWatch.elapsed() << " secs" << endl;
		cout << "[" << i << "] Calender time: " << calenderWatch.elapsed() << " secs" << endl;
	} // for

	return 0;
}

