#include<DataSetTracker.h>
#include<DataSetRecord.h>
#include<Dal.h>
#include<iostream>
#include<vector>

int main() {
    std::string name("datasetrecord.ds");
    DataSet * set = dataSetServer->open(name, Dal::Create);

    DataSetTracker trk;

    DataSetRecord & r = trk.make_record(name);
    r.dataSet(set);
    std::cout << "mode = " << r.mode() << std::endl;
    std::cout << "count = " << r.count() << std::endl;
    ++r; ++r;
    std::cout << "count = " << r.count() << std::endl;
    --r;
    std::cout << "count = " << r.count() << std::endl;

    std::cout << "Global count = " << trk.count() << std::endl;

    dataSetServer->close(set);
    r.dataSet(0);
    std::cout << "Global count = " << trk.count() << std::endl;

    std::cout << "list = " << std::endl;
    trk.list();
    std::cout << "active = " << r.active() << std::endl;
}
