using namespace std;
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// September 2001
//

#include<iostream>
#include<string>
#include <Dal.h>

int main() {
  std::string name("spr1962.ds");
  dataSetServer->client("test");
  DataSet* set = dataSetServer->open(name, Dal::Create);
  Table* tab = set->addTable("table", 10);
  Column* col = tab->addColumn("column", Dal::Int32);
  ColumnData* cd = col->data();
  int32* v = cd->int32Data();
  delete cd;
  col->release();
  // This works
  //  tab->deleteColumn("column");

  longVec size(2,2);
  Array * arr = set->addArray("array", Dal::Int32, size);

  dataSetServer->close(set);

  std::cout << "Set created" << std::endl;

  set = dataSetServer->open(name, Dal::Modify);
  tab = set->table("table");
  col = tab->column("column");
  cd = col->data();
  // addColumn works
  //  tab->addColumn("column2", Dal::Int32);

  // SPR-1962
  // This fails in low memory.
  // Without delete cd, in low mem, deleteColumn will fail.

//    delete cd;

  tab->deleteColumn("column");

  arr = set->array("array");
  ArrayData * ad = arr->data();
  v = ad->int32Data();

  // idem
  //  delete ad;
  set->deleteBlock("array");

  dataSetServer->close(set);
  
}



