using namespace std;
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// September 2001
//
#include<Dal.h>

#include<iostream>
#include<cassert>

#include<cstdlib>
#include<cstring>
#include<fitsio.h>
#include<longnam.h>
int main()
{

  // This is a cfitsio example, where I show that empty string attributes
  // do appear in the output.
  {
    int N = 1000;
    int *arr, i;
    int status = 0;
    fitsfile *fptr;
    /* AI gcc4 porting
     *  deprecated conversion from string constant to char*=> cast to char
     */

    char *ttype1[] = { (char*) "Ivalue", };
    char *tform1[] = { (char*) "1PJ", };
    char *tunit1[] = { (char*) "s", };
    char name1[] =  "X1";
    arr = static_cast<int *>(malloc(N*sizeof(int)));
    for (i=0; i<N; ++i)
      arr[i] = i;
    fits_create_file(&fptr, "!cfits.ds", &status);
    printf("%d", status);
    fits_create_tbl(fptr, BINARY_TBL, 0, 1, ttype1, tform1, tunit1,
		    name1, &status);

    char * key = (char*) "";
    //    fits_write_key(fptr, TSTRING, "string", key, key, &status);
    fits_write_key_longstr(fptr, "string", key, key, &status);

    // the longer the string, the shorter each line

    char * longkey = (char*) "task --param=val --param='val val val' --param1=val1 --param2=val2 --param3='abc def gcf' --param4='abc' --param5=val4 --param='' --param='""'  --param1=val1 --param2=val2 --param3='abc def gcf' --param4='abc' --param5=val4 --param='' --param='""'  --param1=val1 --param2=val2 --param3='abc def gcf' --param4='abc' --param5=val4 --param='' --param='""' ";

    char * longestkey = (char*) "task --param=val --param='val val val' --param1=val1 --param2=val2 --param3='abc def gcf' --param4='abc' --param5=val4 --param='' --param='""'  --param1=val1 --param2=val2 --param3='abc def gcf' --param4='abc' --param5=val4 --param='' --param='""'  --param1=val1 --param2=val2 --param3='abc def gcf' --param4='abc' --param5=val4 --param='' --param='""' task --param=val --param='val val val' --param1=val1 --param2=val2 --param3='abc def gcf' --param4='abc' --param5=val4 --param='' --param='""'  --param1=val1 --param2=val2 --param3='abc def gcf' --param4='abc' --param5=val4 --param='' --param='""'  --param1=val1 --param2=val2 --param3='abc def gcf' --param4='abc' --param5=val4 --param='' --param='""' ";
    fits_write_key_longstr(fptr, "lkey", longkey, key, &status);
    fits_write_key_longstr(fptr, "lstkey", longestkey, key, &status);

    fits_write_col(fptr, TINT, 1, 1, 1, N, arr, &status);
    fits_close_file(fptr, &status);        
    printf("%d", status);
  }

  {
    DataSet * set = dataSetServer->open("cfits.ds", Dal::Read);
    assert(set->table(0)->hasAttribute("string"));
    dataSetServer->close(set);
    std::cout << "cfitsio is ok" << std::endl;
  }


  // empty string attributes disappear from the datasets?
  {
    DataSet * set = dataSetServer->open("stringkeywords.ds", Dal::Create);
    *set->addAttribute("string") = "";
    assert(set->hasAttribute("string"));
    std::cout << "ok before closing" << std::endl;
    dataSetServer->close(set);
    set =  dataSetServer->open("stringkeywords.ds", Dal::Read);
    assert(set->hasAttribute("string"));
    dataSetServer->close(set);
    std::cout << "the dal is ok" << std::endl;
  }

}
      
  
